function fv_algorithm_A

clc;close all;clear all;

disp('This is a program that make the plot of the field of values of a square');
disp('complex matrix based on the algorithm A of the article title');
disp('Revisiting the inverse field of values problem, submitted for publication');
disp('in the ETNA Special Volume on the occasion of Lothar Reichels 60th birthday');
disp(' ');

disp('Programmers:')
disp('Ana Nata (Polytechnic Institute of Tomar, Portugal)')
disp('e-mail: anata@ipt.pt')
disp('J.P. da Providncia (University of Beira Interior, Covilh, Portugal)') 
disp('e-mail: joaodaprovidencia@daad-alumni.de')
disp('Based on a joint work with Natlia Bebiano and J. da Providncia')
disp('University of Coimbra, Portugal')
disp(' ');
disp('December 2013')
disp(' ');

disp('This file is named as fv_algorithm_A.m');
disp('1. run matlab');
disp('2. input this file fv_algorithm_A.m and the routines fv_2x2_def.m and vect.m');
disp('that can be found on http://www.mat-uc.pt/~bebiano');
disp(' ');
disp('INPUTS:'); 
disp('m = '); %positive integer
disp('enter the elements of a square matrix A')
disp('A=;')
disp(' ');
disp('OUTPUTS:'); 
disp('Figure that represents the field of values of the matrix A and');
disp('value of the area of the field of values of A');
disp(' ');
disp('INPUTS e.g., m=20; A=[0 -1/2 0;1/2 0 -1/2; 0 1/2 sqrt(2)]');
disp(' ');
%% INPUTS example
m=20; 
A=[0 -1/2 0;1/2 0 -1/2; 0 1/2 sqrt(2)]; 

%%
tic %beginning of the clock time

m=round(m); %m must be a positive integer
    if m<20 %In same cases, it is convenient that m>20
        m=20; 
    end 
   
if ~isequal(size(A,1),size(A,2))
    error('A must be a square matrix');
end

%When A is a scalar matrix
if isequal(A, A(1,1)*eye(size(A,2)))==1
    plot(real(A(1,1)),imag(A(1,1)),'.cyan', 'MarkerSize',5)
    title('A is a scalar matrix');
    return 
end
    
n=size(A,1);Mdados=[];j=1;
    for r=1:m
        T=(exp(pi*1i*(r-1)/m)*A+exp(-pi*1i*(r-1)/m)*A')/2;
        [x,y]=vect(T,n); 
        Axy=[]; %The matrix Axy is a 2-dimensional compression matrix of A
        Axy(1,1)=x'*(A*x);
        Axy(1,2)=x'*(A*y);
        Axy(2,1)=y'*(A*x);
        Axy(2,2)=y'*(A*y);
        [Mdados,j]=fv_2x2_def(Axy,Mdados,j); %make the plot of the field of values of the matrix Axy 
    end

ReX=[];ImX=[];
    for s=1:size(Mdados,1)
        t=linspace(0,2*pi,180);
        c1=Mdados(s,1);
        c2=Mdados(s,2);
        a=Mdados(s,3);
        b=Mdados(s,4);
        theta=Mdados(s,5);
        x=a*cos(t);
        y=b*sin(t);
        X=cos(theta)*x-sin(theta)*y+c1;
        Y=sin(theta)*x+cos(theta)*y+c2;
        ReX=[ReX real(X)];ImX=[ImX real(Y)];
    end

Ind=convhull(ReX,ImX);
plot(ReX(Ind),ImX(Ind),'color','blue','linewidth',1.5);
xlabel('Real Axis');
ylabel('Imaginary Axis');
axis equal
toc %end of the clock time          
disp(' ');

%Compute the area inside the curve formed by the points of the convex-hull
Area=polyarea(ReX(Ind),ImX(Ind));
fprintf('The area is %e \n', Area);

