function [X,Y]=vect(T,n)

disp('This is a subroutine of the main routine fv_algorithm_A.m');
disp('This routine make the computation of two 1xn orthonormal vectors');
disp('We use the eigenvectors associated to the largest and the smaller');
disp('eigenvalue and the we use the orthonormalization process of Gram-Schmidt');

disp('Programmers:')
disp('Ana Nata (Polytechnic Institute of Tomar, Portugal)')
disp('e-mail: anata@ipt.pt')
disp('J.P. da Providncia (University of Beira Interior, Covilh, Portugal)') 
disp('e-mail: joaodaprovidencia@daad-alumni.de')
disp('Based on a joint work with Natlia Bebiano and J. da Providncia')
disp('University of Coimbra, Portugal')
disp(' ');
disp('December 2013')
disp(' ');

%%
[U,D]=eig(T);
[s,w] = sort(real(diag(D)));
X1=U(:,w(n)); %eigenvector associated to the largest eigenvalue
Y1=U(:,w(1)); %eigenvector associated to the smaller eigenvalue

%Gram-Schmidt's orthogonalization process
X2=X1;
Y2=Y1-(X1'*Y1)*X1/(X1'*X1);

%Normalization of the vectors X2 and Y2
X=X2*(1/sqrt(X2'*X2));
Y=Y2*(1/sqrt(Y2'*Y2));
